/*
 *  display.h
 *
 *  Copyright 2007-2010 Jon Robey, Rachel Robey, and Bob Robey, brobey@lanl.gov 
 *  All rights reserved.
 *  Los Alamos National Laboratory and Supercomputing Challenge
 *  Permission granted for use in Supercomputing Challenge Projects
 */

#ifndef DISPLAY_H_
#define DISPLAY_H_

#include "config.h"

#ifndef USE_MPI
#define MPI_COMM_WORLD 0
#endif

/* Display routines */
void display_init(int *argc, char ***argv, unsigned int iwidth, unsigned int iheight, unsigned int iGraph,
                  double xmin, double xmax, double ymin, double ymax);
void display_data(unsigned int imax, unsigned int jmax, unsigned int my_offset, unsigned int mysize,
                  double **temp, double *x, double *dx, double *y, double *dy);
void display_data_interactive(unsigned int imax, unsigned int jmax, unsigned int my_offset, unsigned int mysize,
                              double **temp,double *x, double *dx, double *y, double *dy,
                              int *button, char *key, int *xloc, int *yloc, double *xcor, double *ycor,
                              int *icell, int *jcell, int *special_event);
void display_set_label(char *text);
void display_get_event(int *button, char *key, int *xloc, int *yloc, double *xcor, double *ycor,
              int *special_event);
void display_close(void);

void display_on(void);
void display_off(void);

void display_set_colorscale(double scale_in);
void display_set_graphscale(double scale_in);
void display_set_graphrow(unsigned int row_in);

void display_set_window(double xmin_in, double xmax_in, double ymin_in, double ymax_in);


#endif /* DISPLAY_H_ */
