/*
 *  memory.h
 *
 *  Copyright 2007-2010 Bob Robey, brobey@lanl.gov . All rights reserved.
 *  Los Alamos National Laboratory and Supercomputing Challenge
 *  Permission granted for use in Supercomputing Challenge Projects
 */

#ifndef MEMORY_H_
#define MEMORY_H_

/* public routines */
double *dvector(int isize);
double **dmatrix(int jsize, int isize);
double ***dtrimatrix(int ksize, int jsize, int isize);
void dvectorfree(double *var);
void dmatrixfree(double **var);
void dtrimatrixfree(double ***var);

float *fvector(int isize);
float **fmatrix(int jsize, int isize);
float ***ftrimatrix(int ksize, int jsize, int isize);
void fvectorfree(float *var);
void fmatrixfree(float **var);
void ftrimatrixfree(float ***var);

int *ivector(int isize);
int **imatrix(int jsize, int isize);
int ***itrimatrix(int ksize, int jsize, int isize);
void ivectorfree(int *var);
void imatrixfree(int **var);
void itrimatrixfree(int ***var);

void memory_free_all(void);

/* helper routines */
void memory_add(void *mem_ptr, int isize);
void memory_free(void *mem_ptr);
size_t memory_report(void);

#endif /* MEMORY_H_ */
